Object subclass: #Boggle

	instanceVariableNames: 'correctGuesses grid gameStatus dictFileName dictionary guessList '

	classVariableNames: ''

	poolDictionaries: ''

	category: 'Assignment3'!





!Boggle methodsFor: 'private'!



checkAlreadyGuessed: aString

"Checks to see if current guess has laready been guessed true/false"



^guessList includes: aString!



checkInDict: aString

"Checks to see if word is in the dictionary (file called dict) true/false"





	^dictionary includes: aString!



grid: aGrid

"Creats a new Gird object"



grid:= aGrid!



grid: aGrid guesses: aInt

"creates a new grid object and sets correct guesses"



grid:= aGrid.

correctGuesses:= aInt.!



grid: aGrid guesses: aInt gameStatus: aBool

"sets all variables and starts timer and calls to read the dictionary"



grid:= aGrid.

correctGuesses:= aInt.

gameStatus:= aBool.

guessList:= Set new.

self startTimer: 180.

self setDictionary.!



setDictionary

"Reads in the dictionary from a file in current directory called dict"



| dictStream dictFile counter temp aString aString2|

temp:= $a.

dictFile:= 'dict' asFilename.

dictStream:= dictFile readStream.

aString:= String new: 1.

aString2:= String new.

dictionary:= Set new.

aString2:= dictStream upTo: (Character cr).

[temp ~= nil] whileTrue: [

	dictionary add:  aString2.	

	temp:= dictStream next.

	(temp ~= nil) ifTrue: [

	aString at: 1 put: (temp).

	aString2:= dictStream upTo: (Character cr).

	aString2:= aString,aString2.]]!



startTimer: aSec

"Starts the timer for aSec seconds"



	[ (Delay forSeconds: aSec) wait.

		gameStatus:= false.

		Transcript show: 'Sorry, game over. '; cr] fork.

		gameStatus:=true.

		Transcript show: 'Begin.'!



tester

" A debugger method"



	^dictionary! !



!Boggle methodsFor: 'printing'!



printOn: aStream

"Calls the Grids printOn to print the grid"



^grid printOn: aStream! !



!Boggle methodsFor: 'accessing'!



correctGuesses

"Returns the number of currect guesses"





^correctGuesses!



gameStatus



^gameStatus.!



gridString



^grid gridString.!



guessList



^guessList!



wordGuess: aString

"Allows the user to make word guesses, checks guessList, on the grid, and in dictionary"



(gameStatus = true) & (aString size >= 3) & ((self checkAlreadyGuessed: aString) = false) ifTrue: [

	(grid checkInGrid: aString) & (self checkInDict: aString) ifTrue: [

		correctGuesses:= 1+correctGuesses.

		guessList add: aString].

]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!



Boggle class

	instanceVariableNames: ''!





!Boggle class methodsFor: 'instance creation'!



start

"Starts the game with a random grid by calling startdWithGrid"



| temp x counter aRand |

aRand:= Random new.

temp:= String new: 16.

counter:=1.



[counter <= 16] whileTrue: [

	x:= ((aRand next) * 50 + 96) asInteger.

	(x < 123) & (x > 96) ifTrue: [

		temp at: counter put: (x asCharacter).

		counter:= counter + 1.]].



^ self startWithGrid: temp!



startWithGrid: aString

"Starts the game with a user chosen Grid"



| temp |



(aString size = 16) ifTrue:  [

	temp:= Grid new: aString.

	^ self new grid: temp guesses: 0 gameStatus: true].



(aString size ~= 16) ifTrue: [Transcript show: 'Grid must be 16 characters'.]! !



!Boggle class methodsFor: 'class initialization'!



initialize

"simple initialization"



| dictStream counter|

counter:= 0.

dictFileName:= 'dict' asFilename.

dictStream:= dictFileName readStream.



dictionary:= Set new.



[counter < (dictionary size)] whileTrue: [

	dictionary add: [dictStream upTo: (Character cr)].

	dictStream next.

	counter:= counter + 1.]! !



View subclass: #TimerView

	instanceVariableNames: ''

	classVariableNames: ''

	poolDictionaries: ''

	category: 'Assignment3'!





!TimerView methodsFor: 'displaying'!



displayOn: aGraphicsContext

"puts a blue circle on the view at desinated x point"

| gc circle x |

x:= self model time.





self model isNil ifTrue: [^self].

gc:= aGraphicsContext.



circle:= Circle center: 30@x radius: 10.

circle asFiller displayOn: (gc paint: ColorValue blue).! !



!TimerView methodsFor: 'model accessing'!



model: aModel

"returns the model"

	super model: aModel.

	self invalidate.! !



!TimerView methodsFor: 'updating'!



update: anAspect

"updates the view"

anAspect == #value

	ifTrue: [self invalidate].! !



!TimerView methodsFor: 'controller accessing'!



defaultControllerClass

^TimerController! !



Object subclass: #TimerModel

	instanceVariableNames: 'time status '

	classVariableNames: ''

	poolDictionaries: ''

	category: 'Assignment3'!





!TimerModel methodsFor: 'actions'!



decrement

"test method"

time:= 50.

self changed: #value.!



decrement: int

"decrements the counter for the ball drop view"

time:= time + int.

self changed: #value.! !



!TimerModel methodsFor: 'accessing'!



status

^status!



status: aBool

status:= aBool.

self changed: #value.!



time

^time.!



time: anInt

time:= anInt.! !



!TimerModel methodsFor: 'initialize-release'!



initialize



	time := 20.

	status:=false.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!



TimerModel class

	instanceVariableNames: ''!





!TimerModel class methodsFor: 'instance creation'!



new



^super new initialize.! !



Object subclass: #Grid

	instanceVariableNames: 'gridString '

	classVariableNames: ''

	poolDictionaries: ''

	category: 'Assignment3'!





!Grid methodsFor: 'private'!



findFirst: aChar

"Finds the first character in the grid equal to aChar returns position in String"



| counter |

counter:=1.

[counter <= 16] whileTrue: [

	( (gridString at: counter) = aChar) ifTrue: [^counter]. 

	counter:= counter + 1].

^0.!



findFirst: aChar afterIndex: aInt

"Finds first char in grid equal to aChar but after index retursn index of String"



| counter |

counter:=aInt + 1.

[counter <= 16] whileTrue: [

	( (gridString at: counter) = aChar) ifTrue: [^counter]. 

	counter:= counter + 1].

^0.!



findNextChar: aChar atIndex: aInt

"Finds a the character given that touches index given"





| x row col y yRow yCol |



x:= aInt.

row:= self getRow: x.

col:= self getCol: x.

y:= self findFirst: aChar.

[y ~= 0] whileTrue: [

	

	(y = 0) ifTrue: [^0].

	yRow:= self getRow: y.

	yCol:= self getCol: y.

	

	(col = yCol) & ( (yRow -1 = row) or: [(yRow + 1 = row)] ) ifTrue: [^y].

	(yCol + 1 = col) & ( (row = yRow) or: [(yRow - 1 = row) or: [(yRow + 1 = row)]] ) ifTrue: [^y].

	(yCol - 1 = col) & ( (row = yRow) or: [(yRow - 1 = row) or: [(yRow + 1 = row)]] ) ifTrue: [^y].

	y:= self findFirst: aChar afterIndex: y.

	].

^0!



findNextChar: aChar atIndex: aInt after: z

"Finds a the character given that touches index given"





| x row col y yRow yCol |



x:= aInt.

row:= self getRow: x.

col:= self getCol: x.

y:= self findFirst: aChar afterIndex: z.

[y ~= 0] whileTrue: [

	

	(y = 0) ifTrue: [^0].

	yRow:= self getRow: y.

	yCol:= self getCol: y.

	

	(col = yCol) & ( (yRow -1 = row) or: [(yRow + 1 = row)] ) ifTrue: [^y].

	(yCol + 1 = col) & ( (row = yRow) or: [(yRow - 1 = row) or: [(yRow + 1 = row)]] ) ifTrue: [^y].

	(yCol - 1 = col) & ( (row = yRow) or: [(yRow - 1 = row) or: [(yRow + 1 = row)]] ) ifTrue: [^y].

	y:= self findFirst: aChar afterIndex: y.

	].

^0!



getCol: aInt

"returns column in grid of index in string"



| x row |

row:= 4.

x:= (16 - aInt).

[x >= 0] whileTrue: [

	(x < 4) ifTrue: [^(x+1)].

	x:= x - 4.

	row:= row - 1 ].!



getRow: aInt

"finds row of grid of index of String"



| x row |

row:=4.

x:= (16 - aInt).

[x >= 0] whileTrue: [

	(x < 4) ifTrue: [^row].

	x:= x - 4.

	row:= row - 1 ].!



gridString: aString

"sets the gridString to given aString"



	gridString:= aString.! !



!Grid methodsFor: 'accessing'!



checkInGrid: aString



"Lets user check to see if aString is in the Grid true/false"



|  letter counter index word count|



word:= aString.

index:=1.

counter:=0.

letter:= (word at: index).

counter:= self findFirst: letter.

count:=counter.

(counter = 0) ifTrue: [^false].

index:= index + 1.

[(index <= (word size) ) & (count <= 16) ] whileTrue: 

	[letter:= word at: index.

	counter:= self findNextChar: letter atIndex: counter.

	(counter = 0) ifTrue: [

		letter:= word at: 1.

		counter:= self findFirst: letter afterIndex: count.

		count:= counter.

		(count = 0) ifTrue: [^false]. 	

	].

	index:= index +1].

^true.!



gridString



^gridString.! !



!Grid methodsFor: 'printing'!



printOn: aStream

"Prints the grid to the workspace"



| str x space |



space:= '        '.

str:= gridString.

x:= 4.

[x <= 16] whileTrue: [

	aStream nextPut: Character cr.

	aStream nextPut: (str at: x - 3).

	aStream nextPutAll: space.

	aStream nextPut: (str at: x - 2).

	aStream nextPutAll: space.

	aStream nextPut: (str at: x - 1).

	aStream nextPutAll: space.

	aStream nextPut: (str at: x).

	aStream nextPut: Character cr.

	x:= x + 4].

"^self storeOn: aStream"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!



Grid class

	instanceVariableNames: ''!





!Grid class methodsFor: 'instance creation'!



new: aString

"Assigns the grid string to given string"



^self new gridString: aString.! !



ApplicationModel subclass: #BoggleGame

	instanceVariableNames: 'gridString wordGuess output guessList gridSpace game word correctGuesses startString Timer TimerM '

	classVariableNames: ''

	poolDictionaries: ''

	category: 'Assignment3'!





!BoggleGame methodsFor: 'initialize-release'!



initialize

"initialize on startup"



	self initializegridString.

	self initializeOutput.

	self initializeguessList.

	self initializegridSpace.

	self initializewordGuess.

	Timer:= TimerView new.

	TimerM:= TimerModel new.

	Timer model: TimerM.

	"self changedTimer."!



initializegridSpace

"initialize gridSpace"

	gridSpace:= SelectionInList new.!



initializegridString

"initialize the grid string"

	gridString := ValueHolder newString.

	gridString onChangeSend: #changedgridString to: self.!



initializeguessList

"initialize guess list"

	guessList := SelectionInList new.!



initializeOutput

"initialize output"

	output := ValueHolder newString.!



initializewordGuess

"initialize word guess"

	wordGuess := ValueHolder newString.

	wordGuess onChangeSend: #changedwordGuess to: self.! !



!BoggleGame methodsFor: 'change messages'!



changedgridString

"update on change for the gridstring"

|x|



x:= self gridString value.

startString:= x.!



changedTimer

"update on change of the Timer"

Timer update: #value.!



changedwordGuess

"update ob change for word guess"

|x|



x:= self wordGuess value.

word:= x.! !



!BoggleGame methodsFor: 'private'!



startTimer

"Starts the timer for aSec seconds"

|correct|

	[ (Delay forSeconds: 115) wait.

	correct:= game correctGuesses.

	self output value: 'Game over. Correct Guesses: ',correct printString.

		 ] fork.!



startTimer: aSec

"Starts the timer for aSec seconds"

|count|

	count:=0.

	[count <= 180] whileTrue: [

	[ (Delay forSeconds: 1) wait.

		TimerM decrement ;cr]fork. 

self changedTimer.

count:= count + 1.

].!



status

"returns status"

^true.! !



!BoggleGame methodsFor: 'actions'!



guess

"Takes the guess word and calls game wordGuess"

|list selectionsInList correct |

self output value: word.

game wordGuess: word.

correct:= game correctGuesses.

selectionsInList := self guessList.

list:= selectionsInList list.

(list includes: word) ifFalse: [list add: word].

self output value: 'Number of Correct Guesses: ',correct printString.!



pause



self changedTimer.!



quit

self initialize.!



start

"starts the game and the view and the timer"

|r1 r2 r3 r4 gridy list selectionInList starter taber|

	taber:= String with: Character tab.

	starter:= self gridString value.

	starter size = 16 ifTrue: [game:= Boggle startWithGrid: starter].

	starter size ~= 16 ifTrue: [game:= Boggle start].

	

	TimerM status: true.

	gridy:= game gridString.

	selectionInList := self gridSpace.

	list:= selectionInList list.

r1:= (gridy copyFrom:1 to:1),taber,(gridy copyFrom:2 to:2),taber,(gridy copyFrom: 3 to:3),taber,(gridy copyFrom:4 to:4).

r2:= (gridy copyFrom:5 to:5),taber,(gridy copyFrom:6 to:6),taber,(gridy copyFrom: 7 to:7),taber,(gridy copyFrom:8 to:8).

r3:= (gridy copyFrom:9 to:9),taber,(gridy copyFrom:10 to:10),taber,(gridy copyFrom: 11 to:11),taber,(gridy copyFrom:12 to:12).

r4:= (gridy copyFrom:13 to:13),taber,(gridy copyFrom:14 to:14),taber,(gridy copyFrom: 15 to:15),taber,(gridy copyFrom:16 to:16).



list add: r1.

list add: ' '.

list add: r2.

list add: ' '.

list add: r3.

list add: ' '.

list add: r4.

selectionInList list: list.

self output value: 'Guess Away'.

TimerM status: true.

self startTimer.

self changedTimer.! !



!BoggleGame methodsFor: 'aspects'!



gridSpace



^gridSpace!



gridString



^gridString!



guessList



^guessList!



output



^output!



Timer



^Timer!



wordGuess



^wordGuess! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!



BoggleGame class

	instanceVariableNames: ''!





!BoggleGame class methodsFor: 'interface specs'!



windowSpec

	"UIPainter new openOnClass: self andSelector: #windowSpec"



	<resource: #canvas>

	^#(#FullSpec 

		#window: 

		#(#WindowSpec 

			#label: 'Boggle' 

			#min: #(#Point 495 370 ) 

			#max: #(#Point 495 370 ) 

			#bounds: #(#Rectangle 127 191 622 561 ) 

			#isEventDriven: false ) 

		#component: 

		#(#SpecCollection 

			#collection: #(

				#(#InputFieldSpec 

					#layout: #(#Rectangle 20 256 157 279 ) 

					#name: #gridString 

					#model: #gridString ) 

				#(#LabelSpec 

					#layout: #(#Point 17 237 ) 

					#label: 'Enter Grid String:' ) 

				#(#ActionButtonSpec 

					#layout: #(#Rectangle 19 287 71 312 ) 

					#model: #start 

					#label: 'Start' 

					#defaultable: true ) 

				#(#ActionButtonSpec 

					#layout: #(#Rectangle 55 322 107 347 ) 

					#model: #pause 

					#label: 'Pause' 

					#defaultable: true ) 

				#(#ActionButtonSpec 

					#layout: #(#Rectangle 99 287 151 312 ) 

					#model: #quit 

					#label: 'Quit' 

					#defaultable: true ) 

				#(#SequenceViewSpec 

					#layout: #(#Rectangle 12 11 163 231 ) 

					#name: #guessList 

					#model: #guessList 

					#useModifierKeys: true 

					#selectionType: #highlight ) 

				#(#SequenceViewSpec 

					#layout: #(#Rectangle 310 16 410 136 ) 

					#name: #gridSpace 

					#flags: 12 

					#model: #gridSpace 

					#useModifierKeys: true 

					#selectionType: #highlight ) 

				#(#InputFieldSpec 

					#layout: #(#Rectangle 310 152 410 177 ) 

					#name: #wordGuess 

					#model: #wordGuess ) 

				#(#LabelSpec 

					#layout: #(#Point 257 153 ) 

					#label: 'Word:' ) 

				#(#ActionButtonSpec 

					#layout: #(#Rectangle 424 151 476 176 ) 

					#model: #guess 

					#label: 'Guess' 

					#defaultable: true ) 

				#(#GroupBoxSpec 

					#layout: #(#Rectangle 12 236 164 357 ) ) 

				#(#InputFieldSpec 

					#layout: #(#Rectangle 264 194 479 219 ) 

					#name: #output 

					#model: #output ) 

				#(#ArbitraryComponentSpec 

					#layout: #(#Rectangle 177 10 228 356 ) 

					#component: #Timer ) ) ) )! !



!BoggleGame class methodsFor: 'interface opening'!



isVisualStartable

^true!



openOnOld: anInstance withSpec: aSpec

	"Override the inherited method to guide user
	toward the appropriate spec:
		- When events are not loaded, eventIgnorantSpec
		- When events are loaded, eventAwareSpec.
	A polling controller is expected in either case."

	| sp |
	sp := (WindowSpec new respondsTo: #isEventDriven)
		ifTrue: [#eventAwareSpec]
		ifFalse: [#eventIgnorantSpec].
	super openOn: anInstance withSpec: sp.! !



ControllerWithMenu subclass: #TimerController

	instanceVariableNames: 'count status done '

	classVariableNames: ''

	poolDictionaries: ''

	category: 'Assignment3'!





!TimerController methodsFor: 'private'!



startTimer

"Starts the timer for aSec seconds"



	count:=0.

[count <= 8] whileTrue: [

count:= count + 1.



	[ (Delay forSeconds: 1) wait.

	self model decrement: count.

		 ] fork.



].!



startTimer: int

"Starts the timer for aSec seconds"



done:=true.

count:=int.

status:=false.

count >= 95 ifTrue: [^true].



	[ (Delay forSeconds: 1) wait.

	count:=count +3.

	self model decrement: count.

	self startTimer: 0] fork.! !



!TimerController methodsFor: 'control'!



controlActivity

"Starts the timer for aSec seconds"

status:= self model status.

(status = true) & (done = false) ifTrue: [self startTimer: 0].!



controlInitialize

"initialization of control"

super controlInitialize!



isControlWanted





^true.! !



!TimerController methodsFor: 'initialize-release'!



initialize



count:= 0.

status:=false.

done:=false.

super initialize.! !

Boggle initialize!





